



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>解决HighChart开发遇到的2个问题</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">解决HighChart开发遇到的2个问题</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-06 05:59:07 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>需求很简单，显示一条24小时的变化曲线</p>
<p>写完代码效果是只有一条直线，连时间轴都没有</p>
<p>第1个错误&nbsp;&nbsp;Highcharts error #12</p>
<p>当通过要绘制的点超过1000个时就会报这个错，我按分钟计算间隔，一天有1440分钟，超过了1000所以报错。</p>
<p>解决办法是在初始化参数中配置</p>
<div>
<pre class="prettyprint linenums">plotOptions: {<br />
       series: {<br />
            turboThreshold: 2000 // 或者更多，必须大于数组长度（1440）<br />
       }<br />
}</pre>
</div>
<p>设置完成后时间轴算是显示出来了，但是不正常，只显示其中的几个小时。&nbsp;而且仍然没有数据，显示为一条直线。</p>
<p>后台明明是有数据传来的，怎么会得不到曲线呢？</p>
<p>后来才发现，数据库的字段是字符型的，所以传到前台js中也是字符型，要手动将其转为数值类型。</p>
<div>
<pre class="prettyprint linenums">parseFloat(chartdata[i][col]);</pre>
</div>
<p>全部代码如下</p>
<div>
<pre class="prettyprint linenums">function drawChart(chartdata, col, cname) {<br />
    var datasource = [];<br />
    for (var i = 0; i &lt; 60 * 24; i++) {<br />
        if (chartdata[i]) {<br />
            var tempval = parseFloat(chartdata[i][col]);<br />
            datasource.push(tempval);<br />
        }<br />
        else {<br />
            datasource.push(null);<br />
        }<br />
    }

    var start = +new Date(GetNowFormatDate() + ' 00:00:00');<br />
    var now = +new Date();

    Highcharts.setOptions({<br />
        global: { useUTC: false },<br />
        lang: {<br />
            contextButtonTitle: '导出',<br />
            printChart: '打印图表',<br />
            downloadJPEG: '导出为JPG',<br />
            downloadPDF: '导出为PDF',<br />
            downloadPNG: '导出为PNG',<br />
            downloadSVG: '导出为SVG',<br />
            loading: '加载中...'

        }<br />
    });<br />
    console.log(datasource);<br />
    $('#container').highcharts('StockChart', {<br />
        chart: {<br />
            events: {<br />
                load: function () {<br />
                    if (!window.isComparing) {<br />
                        this.setTitle(null, {<br />
                            text: '加载完成共消耗  ' + (new Date() - now) + 'ms'<br />
                        });<br />
                    }<br />
                }<br />
            },<br />
            animation: false,<br />
            zoomType: 'x'<br />
        },<br />
        rangeSelector: {<br />
            enabled: false<br />
        },<br />
        tooltip: {<br />
            split: false,<br />
            shared: true<br />
        },<br />
        credits: {<br />
            enabled: false<br />
        },<br />
        yAxis: {<br />
            title: {<br />
                text: '监测值'<br />
            }<br />
        },<br />
        title: {<br />
            text: cname<br />
        },<br />
        series: [{<br />
            name: '监测值',<br />
            data: datasource,<br />
            pointStart: start,<br />
            dataLength: length,<br />
            pointInterval: 1000 * 60,<br />
            tooltip: {<br />
                valueDecimals: 1,<br />
                valueSuffix: ''<br />
            }<br />
        }],<br />
        plotOptions: {<br />
            series: {<br />
                turboThreshold: 2000 // 或者更多，必须大于数组长度（1440）<br />
            }<br />
        }<br />
    });<br />
}</pre>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/2q7lxkg8.html">php多线程详解</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8knx1r8.html">TWebBrowser 调用最新版的Ie  Internet Feature Controls &lpar;B&period;&period;C&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlmlo3x9.html">SQLite介绍、学习笔记、性能测试</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwdv3vz8.html">Package &amp;&num;39&semi;DXCore for Visual Studio&amp;&num;39&semi; has failed to load properly</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k1m54r9.html">iOS导航栏-关闭半透明</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4zgd0j9.html">Friendship of Frog&lpar;水题&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv1262zq.html">关于ToolStrip设置Location无效的问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwjn0kl8.html">ehcache memcache redis 三大缓存对比</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdw0yw09.html">Mysql 了解changeBuffer 与 purge 调优</a>
		</li>
						<li><a href="https://www.batexi.com/a/9r5ggkeq.html">Maven 下载、安装、配置学习</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j1p3pg9.html">需求：lr需要在一串数字中随机位置插入一个新数字的实现方式</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4j6oonq.html">Linux 小知识翻译 - 「端口限制」</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ko05v3q.html">关于css浮动的一点思考</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zkkyk38.html">c&plus;&plus;之五谷杂粮---1</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rn4rp7q.html">TOP100summit 2017：【案例分享】魅族持续交付平台建设实践</a>
		</li>
						<li><a href="https://www.batexi.com/a/9ppx0gk9.html">JAVA架构师面试题 一</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4p36g5q.html">402&period; Remove K Digits&sol;738&period;Monotone Increasing Digits&sol;321&period; Create Maximum Number</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4p6zgjq.html">DAY8-Python学习笔记</a>
		</li>
						<li><a href="https://www.batexi.com/a/93p1vl08.html">装饰器的修复wraps&comma;偏函数partial 以及chain</a>
		</li>
						<li><a href="https://www.batexi.com/a/902gkxjq.html">【转】用JS创建json数据，并且可以动态往json数据里面添加新值，也可以修改值。</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qv2jn5y9.html">ArcSDE账户频繁被锁定（Oracle显示12560协议适配器错误）</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv2jn1x9.html">dp&mdash;&mdash;完全背包（方案数）</a>
			</li>
						<li><a href="https://www.batexi.com/a/9j1vgd09.html">JavaScript 基础篇1</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv2jolo9.html">robot framework程序运行过程中，遇到点击事件之后，未出现点击之后的效果（求解）</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gjzv4e9.html">十六、springcloud&lpar;二&rpar;Eureka集群</a>
			</li>
						<li><a href="https://www.batexi.com/a/960lwej9.html">全面理解Java内存模型&lpar;JMM&rpar;及volatile关键字</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv2jmlj9.html">Spring Cloud&lpar;Dalston&period;SR5&rpar;--Zuul 网关-Hystrix 回退</a>
			</li>
						<li><a href="https://www.batexi.com/a/8m2y5y6q.html">npm  cnpm</a>
			</li>
						<li><a href="https://www.batexi.com/a/8m2y57oq.html">vscode 调试 TypeScript</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kjkx069.html">&lbrack;转&rsqb;jvm调优-命令大全（jps jstat jmap jhat jstack jinfo）</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
